require 'optparse'

class OptParser
    def self.parse(args)
        options = {}
        opts = OptionParser.new do |opts|
            opts.banner = "Usage: #{$0} [options] <arguments>"

            opts.on("-t", "--type <fast,deep>", "Type") do |t|
                options[:type] = t
            end

            opts.on_tail("-h", "--help", "Show this message") do
                puts opts
                exit
            end
        end
        opts.parse!(args)

        options[:type] = "fast" unless %w{fast deep}.include?(options[:type])

        options
    end
end

def get_params
  options = OptParser.parse(ARGV)

  options[:type]
end
